// ZX81 ASSEMBLY & BASIC FILE FOR ZX-IDE
// GET ZX-IDE AT https://www.sinclairzxworld.com/viewtopic.php?f=6&t=1064

; Enable and Disable BREAK KEY
; for 1K ZX81
; BASED ON work by Bean at https://www.sinclairzxworld.com/viewtopic.php?p=19092#p19092

; RAND USR 16521 // start (also re-start after any INPUT command)
; POKE 16569,24  // to disable BREAK key (change 'JR C' to 'JR')
; POKE 16569,56  // to enable BREAK key  (change back to 'JR C')

; BASIC PROGRAM
1 REM _asm
  ;ORIGINAL ROM ROUTINE ORG $066C, BUT IS RELOCATABLE CODE
  NEXT_LINE_CPY:
	     //ROM CALLS
	     TEMP_PTR	     EQU $004D ;TEMP-PTR
	     LINE_RUN	     EQU $0CC1 ;LINE-RUN
	     X_TEMP_NEWROM   EQU $14A3 ;X-TEMP
	     X_TEMP_OLDROM   EQU $149F ;X-TEMP
	     BREAK_1_NEWROM  EQU $0F46 ;BREAK-1
	     BREAK_1_OLDROM  EQU $0F43 ;BREAK-1
	     STOP_LINE	     EQU $06AE ;STOP-LINE
	     //
		LD	(NXTLIN),HL
		EX	DE,HL
		CALL	TEMP_PTR
	L16521: CALL	LINE_RUN
		RES	1,(IY+ FLAGS-$4000)
		LD	A,$C0
		LD	(IY+ X_PTR+1-$4000),A
		CALL	X_TEMP_
		RES	5,(IY+ FLAGX-$4000)
		BIT	7,(IY+ERR_NR-$4000)
		JR	Z,STOP_LINE_CPY
		LD	HL,(NXTLIN)
		AND	(HL)
		JR	NZ,STOP_LINE_CPY
		LD	D,(HL)
		INC	HL
		LD	E,(HL)
		LD	(PPC),DE
		INC	HL
		LD	E,(HL)
		INC	HL
		LD	D,(HL)
		INC	HL
		EX	DE,HL
		ADD	HL,DE
		CALL	BREAK_1_
	L40B9: ;JR	C,NEXT_LINE_CPY
		JR	NEXT_LINE_CPY

		LD	HL,ERR_NR
		BIT	7,(HL)
		JR	Z,STOP_LINE_CPY
		LD	(HL),$0C
  STOP_LINE_CPY:JP	STOP_LINE

      BREAK_1_: CALL   IS_OLDROM
		JP     NZ,BREAK_1_OLDROM
		JP     BREAK_1_NEWROM
		;RET WILL BE HANDLED BY THE ROM ROUTINE

      X_TEMP_:	CALL   IS_OLDROM
		JP     NZ,X_TEMP_OLDROM
		JP     X_TEMP_NEWROM
						 
      IS_OLDROM:;THIS SUBROUTINE RET Z IF IMPROVED ROM
		LD A,(5942)
		CP $D9
		RET
END _asm
; end of program